#include <iostream>
#include "glut.h"
#include "glext.h" 
using namespace std;


class Iluminacao{
    private:
        float luz_Ka_dia;
        float luz_Kd_dia;
        float luz_Ks_dia;
        
        float luz_Ka_noite;
        float luz_Kd_noite;
        float luz_Ks_noite;
        
        float h_spot;
    
    protected:
     
    public:
          
    Iluminacao(){}
    ~Iluminacao(){}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
    void create(void) {
         
        h_spot = - 7.8; 
      
        luz_Ka_dia = 0.5;
        luz_Kd_dia = 1.0;
        luz_Ks_dia = 0.5;
        
        luz_Ka_noite = 0.3;
        luz_Kd_noite = 0.4;
        luz_Ks_noite = 0.5;
      
        GLfloat light_Ka_ambiente[]  =  { 0.0, 0.0, 0.0, 0.0f };
        
        glLightModelfv(GL_LIGHT_MODEL_AMBIENT,       light_Ka_ambiente);
        glLightModelf (GL_LIGHT_MODEL_LOCAL_VIEWER,  GL_FALSE);
        glLightModelf (GL_LIGHT_MODEL_TWO_SIDE,      GL_FALSE);
        glLightModelf (GL_LIGHT_MODEL_COLOR_CONTROL, GL_SEPARATE_SPECULAR_COLOR);  
         
        
        /**************
        /*LUZ Noite
        /**************/  
        
        //VARIAVEIS
           
        GLfloat light0_position[]     =  { 0.0f, 0.0f, 0.0f, 0.0f };
        
        GLfloat light0_Ka_ambiente[]  =  { luz_Ka_noite, luz_Ka_noite, luz_Ka_noite, 1.0f };
        GLfloat light0_Kd_diffuse[]   =  { luz_Kd_noite, luz_Kd_noite, luz_Kd_noite, 1.0f };
        GLfloat light0_Ks_especular[] =  { luz_Ks_noite, luz_Ks_noite, luz_Ks_noite, 1.0f };
         
         
        //CONFIGURAES
        
        glLightfv( GL_LIGHT0, GL_DIFFUSE,  light0_Kd_diffuse);
        glLightfv( GL_LIGHT0, GL_SPECULAR, light0_Ks_especular);    
        glLightfv( GL_LIGHT0, GL_AMBIENT,  light0_Ka_ambiente);   
         
         
        float Kc = 0.00;  
        float Kl = 1.00;  
        float Kq = 100.00;  
        
        glLightf ( GL_LIGHT0, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT0, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT0, GL_QUADRATIC_ATTENUATION, Kq );
        
        
        /**************
        /*LUZ Dia
        /**************/  
        
        //VARIAVEIS
        
        GLfloat light1_Ka_ambiente[]  =  { luz_Ka_dia, luz_Ka_dia, luz_Ka_dia, 1.0f };
        GLfloat light1_Kd_diffuse[]   =  { luz_Kd_dia, luz_Kd_dia, luz_Kd_dia, 1.0f };
        GLfloat light1_Ks_especular[] =  { luz_Ks_dia, luz_Ks_dia, luz_Ks_dia, 1.0f };
         
        
        //CONFIGURAES
        

        glLightfv( GL_LIGHT1, GL_DIFFUSE,  light1_Kd_diffuse);
        glLightfv( GL_LIGHT1, GL_SPECULAR, light1_Ks_especular);    
        glLightfv( GL_LIGHT1, GL_AMBIENT,  light1_Ka_ambiente);   
         
        Kc = 0.00;  
        Kl = 10.00;  
        Kq = 40.00;  
        
        glLightf ( GL_LIGHT1, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT1, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT1, GL_QUADRATIC_ATTENUATION, Kq );
        
        ///**************
        /*LUZ padro
        /**************/  
        
        //VARIAVEIS
        
        GLfloat light2_position[]  =  { 500, 500 , +500, 0.0f };
        
        GLfloat light2_Ka_ambiente[]  =  { 0.05, 0.05, 0.05, 1.0f };
        GLfloat light2_Kd_diffuse[]   =  { 0.8, 0.8, 0.8, 1.0f };
        GLfloat light2_Ks_especular[] =  { 0.8, 0.8, 0.8, 1.0f };
         
        
        //CONFIGURAES
        
        glLightfv( GL_LIGHT2, GL_POSITION, light2_position);
        
        glLightfv( GL_LIGHT2, GL_DIFFUSE,  light2_Kd_diffuse);
        glLightfv( GL_LIGHT2, GL_SPECULAR, light2_Ks_especular);    
        glLightfv( GL_LIGHT2, GL_AMBIENT,  light2_Ka_ambiente);   
         
         
        Kc = 0.00;  
        Kl = 0.00;  
        Kq = 100.00;  
        
        glLightf ( GL_LIGHT2, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT2, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT2, GL_QUADRATIC_ATTENUATION, Kq );  
        
        
        /**************
        /*LUZ Spots
        /**************/  
        
        GLfloat luz_cor[] = {1,1,.4};
        
        GLfloat Spots_Ka_ambiente[]  =  { luz_Ka_dia, luz_Ka_dia, luz_Ka_dia, 1.0f };
        GLfloat Spots_Kd_diffuse[]   =  { luz_Kd_dia, luz_Kd_dia, luz_Kd_dia, 1.0f };
        GLfloat Spots_Ks_especular[] =  { luz_Ks_dia, luz_Ks_dia, luz_Ks_dia, 1.0f };
         
        
        GLfloat Spots_direcao[] = {0,1,0};
        GLfloat Spots_spot_expoente = 2;
        GLfloat Spots_spot_cutoof = 80;
        
        //CONFIGURAES        
        glLightfv( GL_LIGHT3, GL_DIFFUSE,          luz_cor);
        glLightfv( GL_LIGHT4, GL_DIFFUSE,          luz_cor);
        glLightfv( GL_LIGHT5, GL_DIFFUSE,          luz_cor);
        glLightfv( GL_LIGHT6, GL_DIFFUSE,          luz_cor);
        
        glLightfv( GL_LIGHT3, GL_SPECULAR,         luz_cor); 
        glLightfv( GL_LIGHT4, GL_SPECULAR,         luz_cor); 
        glLightfv( GL_LIGHT5, GL_SPECULAR,         luz_cor); 
        glLightfv( GL_LIGHT6, GL_SPECULAR,         luz_cor); 
           
        glLightfv( GL_LIGHT3, GL_AMBIENT,          luz_cor);  
        glLightfv( GL_LIGHT4, GL_AMBIENT,          luz_cor);  
        glLightfv( GL_LIGHT5, GL_AMBIENT,          luz_cor);  
        glLightfv( GL_LIGHT6, GL_AMBIENT,          luz_cor);  
         
        glLightfv( GL_LIGHT3, GL_SPOT_DIRECTION ,  Spots_direcao);  
        glLightfv( GL_LIGHT4, GL_SPOT_DIRECTION ,  Spots_direcao);
        glLightfv( GL_LIGHT5, GL_SPOT_DIRECTION ,  Spots_direcao);
        glLightfv( GL_LIGHT6, GL_SPOT_DIRECTION ,  Spots_direcao); 
        
        glLightf( GL_LIGHT3, GL_SPOT_EXPONENT ,    Spots_spot_expoente); 
        glLightf( GL_LIGHT4, GL_SPOT_EXPONENT ,    Spots_spot_expoente); 
        glLightf( GL_LIGHT5, GL_SPOT_EXPONENT ,    Spots_spot_expoente); 
        glLightf( GL_LIGHT6, GL_SPOT_EXPONENT ,    Spots_spot_expoente); 
        
        glLightf( GL_LIGHT3, GL_SPOT_CUTOFF,       Spots_spot_cutoof); 
        glLightf( GL_LIGHT4, GL_SPOT_CUTOFF,       Spots_spot_cutoof);
        glLightf( GL_LIGHT5, GL_SPOT_CUTOFF,       Spots_spot_cutoof);
        glLightf( GL_LIGHT6, GL_SPOT_CUTOFF,       Spots_spot_cutoof);
               
         
         
        Kc = 0.5;  
        Kl = 0;  
        Kq = 0;  
        
        glLightf ( GL_LIGHT3, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT4, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT5, GL_CONSTANT_ATTENUATION,  Kc );
        glLightf ( GL_LIGHT6, GL_CONSTANT_ATTENUATION,  Kc );
        
        glLightf ( GL_LIGHT3, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT4, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT5, GL_LINEAR_ATTENUATION,    Kl );
        glLightf ( GL_LIGHT6, GL_LINEAR_ATTENUATION,    Kl );
        
        glLightf ( GL_LIGHT3, GL_QUADRATIC_ATTENUATION, Kq );
        glLightf ( GL_LIGHT4, GL_QUADRATIC_ATTENUATION, Kq );
        glLightf ( GL_LIGHT5, GL_QUADRATIC_ATTENUATION, Kq );
        glLightf ( GL_LIGHT6, GL_QUADRATIC_ATTENUATION, Kq );
    
    
    }

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 


      void set_material(float r, float g, float b,float a, float s, float em,char c){
           
           set_material( r,  g,  b, a, 
                         r,  g,  b, a,
                         s,  s,  s, a,
                        0, 0, 0, a,
                        20,  c);
           
      }  

    void set_material(float Kar, float Kag, float Kab,float Kaa, 
                      float Kdr, float Kdg, float Kdb,float Kda,
                      float Ksr, float Ksg, float Ksb,float Ksa,
                      float Ker, float Keg, float Keb,float Kea,
                      float se, char c){
        
        
        float material_Ka[] = {  Kar,  Kag,  Kab, Kaa};
        float material_Kd[] = {  Kdr,  Kdg,  Kdb, Kda};
        float material_Ks[] = {  Ksr,  Ksg,  Ksb, Ksa};
        float material_Ke[] = {  Ker,  Ker,  Ker, Ker};
        float material_Se = se;
         
        if(c=='d'){ 
            glMaterialfv (GL_FRONT_AND_BACK, GL_AMBIENT,  material_Ka); 
            glMaterialfv (GL_FRONT_AND_BACK, GL_DIFFUSE,  material_Kd);   
            glMaterialfv (GL_FRONT_AND_BACK, GL_SPECULAR, material_Ks);
            glMaterialfv (GL_FRONT_AND_BACK, GL_EMISSION, material_Ke); 
            glMaterialf  (GL_FRONT_AND_BACK, GL_SHININESS,material_Se);  
        }  
        if(c=='f'){ 
            glMaterialfv (GL_FRONT, GL_AMBIENT,  material_Ka); 
            glMaterialfv (GL_FRONT, GL_DIFFUSE,  material_Kd);   
            glMaterialfv (GL_FRONT, GL_SPECULAR, material_Ks);
            glMaterialfv (GL_FRONT, GL_EMISSION, material_Ke); 
            glMaterialf  (GL_FRONT, GL_SHININESS,material_Se);  
        } 
        if(c=='b'){ 
            glMaterialfv (GL_BACK, GL_AMBIENT,  material_Ka); 
            glMaterialfv (GL_BACK, GL_DIFFUSE,  material_Kd);   
            glMaterialfv (GL_BACK, GL_SPECULAR, material_Ks);
            glMaterialfv (GL_BACK, GL_EMISSION, material_Ke); 
            glMaterialf  (GL_BACK, GL_SHININESS,material_Se);  
        } 
              
    }



    void move_luz(float x, float y, float z, float x1, float y1, float z1) {
      
    
    
        GLfloat light0_position[]     =  { -x,  -y,   -z, 0.0f };
        GLfloat light1_position[]     =  { -x1, -y1, -z1, 0.0f };
        //CONFIGURAES
        
        glLightfv( GL_LIGHT0, GL_POSITION, light0_position);
        glLightfv( GL_LIGHT1, GL_POSITION, light1_position);
    }
    
     void ControlaLuz(float fatordia, float fatornoite) {
            
         GLfloat luz_Ka ;
         GLfloat luz_Kd ;
         GLfloat luz_Ks ;
            
            /**************
            /*LUZ Noite
            /**************/  
            if (fatornoite<=1){   
               luz_Ka = luz_Ka_noite * fatornoite;
               luz_Kd = luz_Ka_noite * fatornoite;
               luz_Ks = luz_Ka_noite * fatornoite;
            }else{
                luz_Ka = 0;
                luz_Kd = 0;
                luz_Ks = 0;
            }
            
            
            GLfloat light0_Ka_ambiente[]  =  { luz_Ka, luz_Ka, luz_Ka, 1.0f };
            GLfloat light0_Kd_diffuse[]   =  { luz_Kd, luz_Kd, luz_Kd, 1.0f };
            GLfloat light0_Ks_especular[] =  { luz_Ks, luz_Ks, luz_Ks, 1.0f };
             
            //CONFIGURAES
            glLightfv( GL_LIGHT1, GL_DIFFUSE,  light0_Kd_diffuse);
            glLightfv( GL_LIGHT1, GL_SPECULAR, light0_Ks_especular);    
            glLightfv( GL_LIGHT1, GL_AMBIENT,  light0_Ka_ambiente);  
              
              
            //**************
            /*LUZ Dia
            /**************/  
          
             if (fatordia){
                luz_Ka = luz_Ka_dia* fatordia;
                luz_Kd = luz_Kd_dia * fatordia;
                luz_Ks = luz_Ks_dia * fatordia;
             }else{
                luz_Ka = 0;
                luz_Kd = 0;
                luz_Ks = 0;
             }
            
            
            

            GLfloat light1_Ka_ambiente[]  =  { luz_Ka, luz_Ka, luz_Ka, 1.0f };
            GLfloat light1_Kd_diffuse[]   =  { luz_Kd, luz_Kd, luz_Kd, 1.0f };
            GLfloat light1_Ks_especular[] =  { luz_Ks, luz_Ks, luz_Ks, 1.0f };
                 
        //CONFIGURAES
             
            glLightfv( GL_LIGHT1, GL_DIFFUSE,  light1_Kd_diffuse);
            glLightfv( GL_LIGHT1, GL_SPECULAR, light1_Ks_especular);    
            glLightfv( GL_LIGHT1, GL_AMBIENT,  light1_Ka_ambiente);   
 
    
    }
    
    void move_spot(float x, float z) {
         
         GLfloat light3_position[]  =  { -x, h_spot, -z, 1.0f };
         glLightfv( GL_LIGHT3, GL_POSITION, light3_position);
         
         GLfloat light4_position[]  =  { -x, h_spot, z, 1.0f };
         glLightfv( GL_LIGHT4, GL_POSITION, light4_position);
         
         GLfloat light5_position[]  =  { x, h_spot, z, 1.0f };
         glLightfv( GL_LIGHT5, GL_POSITION, light5_position);
         
         GLfloat light6_position[]  =  { x, h_spot, -z, 1.0f };
         glLightfv( GL_LIGHT6, GL_POSITION, light6_position);
         
    }

};



   

