/**************
/Authors: Alex & Jess 
/Company: Unicamp
/**************/

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//BIBLIOTECAS
#include <windows.h> 
#include <math.h>
#include <time.h>
#include <iostream>
#include <fstream>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "glut.h"
#include "glext.h" 
#include "glaux.h"
#include "glm.c"


//CLASSES
#include "Iluminacao.cpp"
#include "HUD.cpp"
#include "image.c"
#include "Texto.cpp"
#include "Neblina.cpp"

using namespace std;  


//CONSTANTES

#define velocidade_fullscreen 8     //Em pcs rpidos, usar 6 e 12

#define dormencia true

////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS PRINCIPAIS
void init(void);
void display(void);
void reshape (int w, int h);

void listas();

GLuint lista_catapulta, lista_roda, lista_atirador, lista_castelo, lista_grade , 
lista_skibox_face, lista_projetil1,lista_projetil2,lista_projetil3,
lista_skibox, lista_portao, lista_terreno, lista_terrenoA , lista_terrenoB,
lista_tocha,  lista_Arvore1, lista_Arvore2, lista_Arvore3, lista_Arvore4;

void valores_iniciais();
void ControleFPS(void);
int medidor_fps(void);



//VARIAVEIS PRINCIPAIS
float trans_ang = M_PI/180;

int largura  = 800;                    //Dimenso da Janela
int altura = 600;
float ratio;                           //Proporo de Largura X Altura

int largura_at_full;
int altura_at_full;
            
            
int pos_x_full;
int pos_y_full;

int frameRate = 0;
int FPS_max = 28;

void Tela_Inicial();
float inicio = 1;
void Final();

int Fim_de_jogo = false;
bool ganhou = false;


int WireFrame = 1;



/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO Interface///////////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Interface();


/////////////////////////////////VARIAVEIS//////////////////////////////////////
float rcor_base_porj1 = .0;
float bcor_base_porj1 = .5;
float gcor_base_porj1 = .5;
        
float rcor_base_porj2 = .8;
float gcor_base_porj2 = .8;
float bcor_base_porj2 = .8;
        
float rcor_base_porj3 = .8;
float gcor_base_porj3 = .8;        
float bcor_base_porj3 = .8;


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE TECLADO
void keyboard_pressionar(int key,register int x,register int y);
void keyboard_soltar(int key,register int x,register int y);
void keyboard_normal(unsigned char key,register int x,register int y);
void mov_camera(int i);
void virar_camera(float ang);


//VARIAVEIS DO SISTEMA DE TECLADO
float angle=0.0, deltaAngle = 0.0;

float xx=0.0f, yy=3.2f, zz=70.0f;
float lx=0.0f, ly=0.0f, lz=-1.0f;
short deltaMove = 0;



//CONSTANTES




////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE MOUSE
void mouse_click(int button, int state, int x, int y);
void menu_click(int value);
void MoveMouse(int x, int y);

void TrataBotaoDireito();


//VARIAVEIS DO SISTEMA DE MOUSE

float x_HUD = 0;
float y_HUD = 0;


////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO LOADER
GLMmodel* drawmodel(char *string, char *type);

//VARIAVEIS DO LOADER
GLMmodel* pmodel1 = NULL;




////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//CRIANDO OBJETOS PARA OS SISTEMAS DESAJADOS

HUD HUD_System;
Texto Text_System;
Neblina Nevoa;


//////////////////////////////Luz///////////////////////////////////
Iluminacao Light_System;

void move_luz(); 

bool dia = true;

float ang_sol  = 45;
float ang_lua  = ang_sol + 180;

float incr_luz = 0.01;

float intencidade_sol;
float intencidade_lua;

float ang_desl_luz = 0.35877067;
float raio_luz = 854.4003747;

float px_luz_sol;
float py_luz_sol;
float pz_luz_sol;

float px_luz_lua;
float py_luz_lua;
float pz_luz_lua;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DA CATAPULTA//////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////
void Catapulta();
bool AndarCatapulta();


/////////////////////////////////VARIAVEIS//////////////////////////////////////

float ang_atirador = 0.0;
float ang_catapulta = 0.0;
float x_catapulta = 0.0; 
float y_catapulta = 1.7; 
float z_catapulta = 0.0; 

float Mov_Catap = 0.3;
float Giro_Catap = 1;

float ang_roda_dir = 0;
float ang_roda_esq = 0;

float Desloc_Catap = 0;
float Virar_Catap = 0;

/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO MURO///////////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Muro();
void Colisao();
void calcula_score();
void portao_caindo();

/////////////////////////////////VARIAVEIS//////////////////////////////////////
int score_portao = 300;
float ang_portao = 0;
float incr_portao = -1;
bool mov_portao = false;
bool portao = true;

int colisao = -1;
int colisao_muro = -1;

float x_muro = -100;
float h_muro = 24;
float lag_muro = 93;

float h_portao = 14;
float w_portao = 17.6;


/////////PROTOTIPOS E VARIAVEIS DE CONSTRUO DO PROJETIL///////////////////////

/////////////////////////////////PROTOTIPOS/////////////////////////////////////

void Projetil();
void Projetil1();
void Projetil2();
void Projetil3();
void MovimentoCircular();
void MovimentoProjetil();
void AtualizarCoord();

/////////////////////////////////VARIAVEIS//////////////////////////////////////
float ang_projetil =0;
int projetil = 1;
int projetil_dis;

float massa_projetil_A = 1;
float massa_projetil_B = 2;
float massa_projetil_C = 3;

int q_proj_A = 6;
int q_proj_B = 4;
int q_proj_C = 2;

int total_projetil = q_proj_A+q_proj_B+q_proj_C;

float  ang_disparo = 45;


float  raio = 5.175;
int div_tempo = 1000;


float  x_inicial = (x_catapulta);
float  y_inicial = y_catapulta;
float  z_inicial = (z_catapulta);

float  x_circ_final = 0;
float  y_circ_final = 0;
float  z_circ_final = 0;

float x_projetil = x_inicial + (cos(ang_catapulta*trans_ang)*raio);
float y_projetil = y_inicial;
float z_projetil = z_inicial - (sin(ang_catapulta*trans_ang)*raio);

float y_projetil_final;
float x_projetil_final;
float z_projetil_final; 

float  h_final = 0;

float  Forca = 35;
float  massa = massa_projetil_A;
 

float  aceleracao = 0;
float  aceleracao_ang = 0;
float  velocidade = 0;
float  vel_vert = 0;
float  vel_horiz = 0;
float  Delta_ang = 0;
float  tempo_inicial =  0;
float  Delta_tempo = 0;

float  ang_proj = 0;
 
 
bool   mov_circ  = false;
bool   mov_proj  = false;
bool   disparar  = false;
bool   carregar = true;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////





////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//PROTOTIPOS DO SISTEMA DE TEXTURA
void carregar_texturas(GLuint id, char *NomeArquivo);
void carregar_texturas_sprite(GLuint id, char *NomeArquivo, int faixa);



//VARIAVEIS DO SISTEMA DE TEXTURA
GLuint textura[4];                        //Armazena Texturas RGB

int g_keyColor[3] = { 255, 255, 255};          //Armazena Texturas BMP para os Sprites

void SkiBox();

void Terreno();

void Arvores();

void Tocha();

void CalculaNeblina();

short flag_nevoa = 0;



////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM - MAIN PROGRAM//
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
int main(int argc, char** argv){
cout<<"Iniando Console... ";

glutInit(&argc, argv);                                      //Caminho do arquivo
glutInitDisplayMode (GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA); //Modo de vizualizao
glutInitWindowSize (largura, altura);                              //Tamanho da janela
glutInitWindowPosition (0,0);                          //Posio da janela



if(!glutCreateWindow("Crush that Gate!"))                     //Criar janela
    {
    MessageBox(NULL,"Falha ao criar janela.","Erro Fatal",MB_OK|MB_ICONERROR );
    return 0;
    exit(-1);
    }                                 

init ();                                                    //Inicializao principal




glutIgnoreKeyRepeat(1);                                     //Sistema de teclado
glutKeyboardFunc(keyboard_normal);
glutSpecialFunc(keyboard_pressionar);                                  
glutSpecialUpFunc(keyboard_soltar);   

glutMouseFunc(mouse_click);                                 //Sistema de Click de mouse                             

glutDisplayFunc(display);                                   //Desenho (Render)

glutIdleFunc(display);                                      //Funo callback de Render
glutReshapeFunc(reshape);                                   //Redimensionar Janela
glutMainLoop();                                             //Loop principal

return TRUE;
}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void init(void)
{    

//CARREGANDO TEXTURAS
cout<<"..OK!\nCarregando texturas...";  
carregar_texturas(1,"textures/ceu_dia.rgb");cout<<"..1.";  
carregar_texturas(2,"textures/ceu_noite.rgb");cout<<"..2.";  
carregar_texturas(4,"textures/menu.rgb");cout<<"..3.";  


//INICIANDO CONFIGURACOES PADROES
cout<<"..OK!\nCrianto GL_LISTS... ";  

listas();
cout<<"GL_LISTS...OK!\nDefinindo configuracoes iniciais... ";  

glClearColor (0, 0, 0, 0);                  //Cor de fundo
valores_iniciais();
Light_System.create();
Nevoa.create(0.0,1000,0,150);

cout<<"(OK)"; 

}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void display(void)
{ 	     


/***************
/VARIAVEIS
/***************/
static GLUquadricObj *quadric = gluNewQuadric();    //Iniciando objetos Quadrics
   
     

    ControleFPS();

    if(!Fim_de_jogo && inicio < 0){
        if (deltaMove)
        	mov_camera(deltaMove);
        if (deltaAngle) 
            {
        	angle += deltaAngle;
        	virar_camera(angle);
        	}
       	if(Desloc_Catap){
            
            bool andou = AndarCatapulta();
            if(andou)if(Desloc_Catap>0){
                 ang_roda_dir -= Mov_Catap*(14);
                 ang_roda_esq -= Mov_Catap*(14);
            }else{
                 ang_roda_dir += Mov_Catap*14;
                 ang_roda_esq += Mov_Catap*14;
            }
            
            if(!disparar){
               AtualizarCoord();
            }
         
        
        if(Virar_Catap){
                float ang_aux = 0;
                          
                if(Desloc_Catap>0)            
                     ang_aux = Virar_Catap * -1;
                else
                     ang_aux = Virar_Catap;
                    
                ang_catapulta += ang_aux;
                    
                float mult = 1;
                if(Virar_Catap>0){
                     ang_roda_dir -= Giro_Catap*mult;
                     ang_roda_esq += Giro_Catap*mult;
                }else{
                     ang_roda_dir += Giro_Catap*mult;
                     ang_roda_esq -= Giro_Catap*mult;
                }
                
                if(!disparar){
                   AtualizarCoord();
                }
              }
          }
    }
    
    
    /***************
    /CFG INICIAL
    /***************/
    
    glClear (GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);        //Limpando buffers  
    
    if(WireFrame){
         glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);         
    }else{
         glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); 
    }
  
    glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_REPLACE);   //Definindo filtro de textura
    gluQuadricTexture(quadric, GL_TRUE);                        //Ativando Texturizao de quadrics

    
    
    
    glEnable(GL_AUTO_NORMAL);                                   //Gerar normais automatimaticamente
    glEnable(GL_NORMALIZE);  
    glEnable(GL_DEPTH_TEST);                                    //TESTA PROFUNDIDADE P/ EXIBIR SEM SOBREPOSICAO
    glShadeModel(GL_SMOOTH);                                    //SECIONA O TIPO DE SHADER. EX: GL_FLAT
    

    

    glPushMatrix();
        
        move_luz();
        Light_System.move_luz(px_luz_sol,py_luz_sol,pz_luz_sol,px_luz_lua,py_luz_lua,pz_luz_lua);
        
    glPopMatrix();
    
    Light_System.ControlaLuz(intencidade_sol,intencidade_lua);
    
    Light_System.move_spot(-30,-30);
    
    glEnable(GL_LIGHTING);   //Ligando Luz
    
     
    
    if(flag_nevoa==0){
             Nevoa.liga(1-intencidade_lua,.2,.2,.2,1-intencidade_lua);
    }
    
    
    
    glEnable(GL_LIGHT1);
    glEnable(GL_LIGHT0);       
    
    SkiBox();
    
    if(intencidade_lua < 0.7){   
           glEnable(GL_LIGHT3);
           glEnable(GL_LIGHT4);
           glEnable(GL_LIGHT5);
           glEnable(GL_LIGHT6);
    }
    
    
        
    
        Projetil();  
        Terreno();    
        Tocha();                 
        Catapulta();
        Muro();
        
     
    glEnable(GL_BLEND);                                         //habilita as funes transparencia
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);           //Define como  feita a mistura de cor para o alpha
    glEnable(GL_ALPHA_TEST);                                    //Habilita o rotacao_animacao alpha
    
        Arvores();
         

    glDisable(GL_LIGHT0);
    glDisable(GL_LIGHT1);
    
    glDisable(GL_LIGHT3);
    glDisable(GL_LIGHT4);
    glDisable(GL_LIGHT5);
    glDisable(GL_LIGHT6);
    
    
    glDisable(GL_LIGHTING); 

    
    Nevoa.desliga();  
    
    Interface();  
    if(Fim_de_jogo)
            Final();
     
     if(inicio >0 ){        
         Tela_Inicial();
         if(inicio<=.99){
             inicio = inicio -.05; 
         }
    }
    
    glDisable(GL_BLEND);  
   			  
    glutSwapBuffers();  

}


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
void reshape (int w, int h)
{
  	if(h == 0)                       
		h = 1;
    
    largura = w;
    altura = h;
    
    
	ratio = 1.0f * largura / altura;
	
	glMatrixMode(GL_PROJECTION);     
	glLoadIdentity();
  
    glViewport(0, 0, w, h);          
	gluPerspective(45,ratio,1,2000);                  
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST); 
    
    
    glMatrixMode(GL_MODELVIEW);    
	glLoadIdentity();
	gluLookAt(xx,      yy,      zz,   
		      xx + lx, yy + ly, zz + lz,
			  0.0f,   1.0f,   0.0f);
			  
                
}  


////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////
//TECLADO
void keyboard_pressionar(int key,register int x,register int y) {


	switch (key) 
    {
       
		case GLUT_KEY_INSERT : deltaAngle = -0.045f;
        break;
		
        case GLUT_KEY_PAGE_UP : deltaAngle = 0.045f;
        break;
		
        case GLUT_KEY_HOME : 

            deltaMove = velocidade_fullscreen;
      
        break;
		
        case GLUT_KEY_END :
    
            deltaMove = -velocidade_fullscreen;
        
        break;
        
        case GLUT_KEY_UP:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Desloc_Catap =  -Mov_Catap;
        
        break;
        
        case GLUT_KEY_DOWN:
             if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Desloc_Catap =  Mov_Catap;
        
        break;
 
        case GLUT_KEY_LEFT:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Virar_Catap =  Giro_Catap;
        break;
        case GLUT_KEY_RIGHT:
            if ((!disparar && !mov_circ)||(disparar && mov_circ))
                   Virar_Catap =  -Giro_Catap;

        break;
 
        

   }


}

void keyboard_soltar(int key,register int x,register int y) 
{
     
	switch (key) 
    {
		case GLUT_KEY_HOME: 
		case GLUT_KEY_END: 
             deltaMove = 0;
        break;	
        
		case GLUT_KEY_INSERT: 
		case GLUT_KEY_PAGE_UP: 
             deltaAngle = 0.0f;
        break;
        
        case GLUT_KEY_UP:       
        case GLUT_KEY_DOWN:
    
            Desloc_Catap = 0;
        
        break;
        
        case GLUT_KEY_LEFT:
        case GLUT_KEY_RIGHT:
                   Virar_Catap =  0;
        break;
        case GLUT_KEY_F1:
            
            static bool flag_full = false; 
            
            
            
            if (!flag_full){
                 largura_at_full= largura;
                 altura_at_full = altura;
            
                 pos_x_full = GLUT_WINDOW_X;
                 pos_y_full = GLUT_WINDOW_Y;
                 
                 glutFullScreen();
                 
                 flag_full=!flag_full;
                 
            }else{
			     glutReshapeWindow(largura_at_full,altura_at_full);
                 glutPositionWindow(20,20); 
                 flag_full=!flag_full;
            }
        break;
	}

}

void keyboard_normal(unsigned char key,register int x,register int y) 
{

	switch (key) 
    {
           
        case 'm' :        
		case 'M' : 
             
             inicio = 1;
             
        break;
           
        case 13 :        
		case 32 : 
             
             inicio -= .05;
             
        break;
           
        case 'w' :        
		case 'W' : 
             
             WireFrame = !WireFrame;
             
        break;
        
		case 'r' :        
		case 'R' : 
             if(Fim_de_jogo)
                      break;
        case 'n' :        
		case 'N' : 
	             carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 AtualizarCoord();
                 
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;
                 
                 q_proj_A = 6;
                 q_proj_B = 4;
                 q_proj_C = 2;
                 
                 total_projetil = q_proj_A+q_proj_B+q_proj_C;
                 
                 colisao =-1;   
                 score_portao = 300;
                 ang_portao = 0;
                 mov_portao = false;
                 portao = true;
                 
                 Fim_de_jogo = false;
                 ganhou = false;
                 
                 valores_iniciais();
                 
	         
        break;
        
        case 'd' : 
        case 'D' :
             if (carregar && !Fim_de_jogo && inicio<0){
                int proj_existe = 0; 
                switch (projetil){
                         
                     case 1 : if(q_proj_A>0)proj_existe =1;
                     break;
                          
                     case 2 : if(q_proj_B>0)proj_existe =1;
                     break;
                          
                     case 3 : if(q_proj_C>0)proj_existe =1;
                     break;
                          
                } 
                projetil_dis =  projetil;       
    	        if(proj_existe){
                    disparar  = true;
    	            carregar = false;
    	            switch (projetil){
                         
                          case 1 : q_proj_A--;
                                   total_projetil--;
                          break;
                          
                          case 2 : q_proj_B--;
                                   total_projetil--;
                          break;
                          
                          case 3 : q_proj_C--;
                                   total_projetil--;
                          break;
                          
                    } 
                 }
             }
        break;
        
        
        case 'c' : 
        case 'C' :
             if (disparar && mov_circ && mov_proj && !mov_portao && !Fim_de_jogo && inicio<0){
                 carregar  = true;
                 disparar  = false;
                 mov_circ  = false;
                 mov_proj  = false;
                 
                 AtualizarCoord();
                 
                 tempo_inicial = 0;
                 Delta_ang = 0;
                 ang_atirador = 0;      
                 
                 colisao =-1;    
                 
                 projetil =  projetil_dis;        
                 
             }
        break;
        
        case 'A' :
             if (ang_disparo >= 0){
                 ang_disparo -= 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo maximo de disparo  de 90.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'a' : 
             if (ang_disparo < 90 ){
                 ang_disparo += 0.5 ;
                 cout<<"\nAngulo de Disparo: " << ang_disparo;
             }else{
                cout<<"\nO angulo minimo de disparo  de 0.\nAngulo de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'F' :
             if (Forca >= 10){
                 Forca -= 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora maxima de disparo  de 80N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        
        case 'f' : 
             if (Forca < 90){
                 Forca += 0.5 ;
                 cout<<"\nFora de Disparo: " << Forca;
             }else{
                cout<<"\nA fora minima de disparo  de 10N.\nFora de Disparo Atual: " << ang_disparo; 
             }
        break;
        

        
        case '1' : Projetil1();
            
        break;
        
        case '2' : Projetil2();
         
        break;
        
        case '3' : Projetil3();
           
        break;
        
        case 27 : 
             exit(0);
        break;
        
	}


}   


void mouse_click(int button, int state, int x, int y) 
{  
    x_HUD = (float)x/(float)largura;
    y_HUD = 1-((float)y/(float)altura);
    if(state == GLUT_DOWN && button==0){
             
             TrataBotaoDireito();
		
	} 
		
	
}

////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////// 
void virar_camera(float ang) 
{

lx = sin(ang);
lz = -cos(ang);
glLoadIdentity();
gluLookAt(xx,     yy,     zz, 
		  xx + lx,yy + ly,zz + lz,
		  0.0f,  1.0f,  0.0f);
}


//////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////// 
void mov_camera(int i) 
{                   

xx = xx + (i*lx*0.1);
zz = zz + (i*lz*0.1);


glLoadIdentity();  

gluLookAt(xx     ,yy     ,zz, 
		      xx + lx, yy + ly, zz + lz,
		      0.0f   ,1.0f   ,0.0f);
        

}   

 

     
////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////         
GLMmodel* drawmodel(char *string, char *type)
{
    GLMmodel* pmodel = NULL;
    if (!pmodel) {
        pmodel = glmReadOBJ(string);
        if (!pmodel) exit(0);
        glmFacetNormals(pmodel);
        glmVertexNormals(pmodel, 0);
    }    

return pmodel;
}




//****************************************************************************//
//////////////////////////Catapulta/////////////////////////////////////////////

void Catapulta(){


glPushMatrix(); 
    
    glTranslatef(x_catapulta, y_catapulta, z_catapulta);  
    glRotatef(ang_catapulta,0,1,0);
     
    glPushMatrix(); 
       glTranslatef(-3.25,-0.7,2.5);
       glRotatef(ang_roda_dir,0,0,1);
       glCallList(lista_roda);
    glPopMatrix();
    
    glPushMatrix(); 
       glTranslatef(3.25,-0.7,2.5);
       glRotatef(ang_roda_dir,0,0,1);
	   glCallList(lista_roda);
    glPopMatrix();
    
    
    glCallList(lista_catapulta);
    
    
    
    glPushMatrix();
        glRotatef(ang_atirador,0,0,1);
	    glCallList(lista_atirador);
    glPopMatrix();   

      
    glPushMatrix(); 
       glTranslatef(-3.25,-0.7,-2.5);
       glRotatef(ang_roda_esq,0,0,1);
	   glCallList(lista_roda);
    glPopMatrix();
    
    glPushMatrix(); 
       glTranslatef(3.25,-0.7,-2.5);
       glRotatef(ang_roda_esq,0,0,1);
	   glCallList(lista_roda);
    glPopMatrix();
    

glPopMatrix();

     
}

//****************************************************************************//
/////////////////////////////////////PROJETIL///////////////////////////////////

void Projetil(){     


glPushMatrix();
    
    if((colisao == -1) && disparar){
         Colisao();                    
    }

    if(disparar && !mov_circ){
         MovimentoCircular();
    }
    
    if(disparar && mov_circ && !mov_proj){
          MovimentoProjetil();
    }
    
    
    glTranslatef(x_projetil,y_projetil,z_projetil);
    
    if(!mov_proj && mov_circ)
          ang_proj += 5;
    glRotatef(ang_proj,1,1,1);
    
    
    	switch (projetil) 
    {
		case 1: if(q_proj_A || (disparar && !q_proj_A)){
             
                  glCallList(lista_projetil1); 
              }
              
        break;	
        
		case 2: if(q_proj_B  || (disparar && !q_proj_B)){
             
                  glCallList(lista_projetil2); 
                  
              }
        break;
        
        case 3: if(q_proj_C  || (disparar && !q_proj_C)){
                  
    		      glCallList(lista_projetil3); 
              }             
        break;
	}
    

glPopMatrix();


     
};

////////////////////////////////////////////////////////////////////////////////
void MovimentoCircular(){ 
      Desloc_Catap = 0;  
      
      
      if(tempo_inicial == 0){
            tempo_inicial = timeGetTime ();      
      }
      Delta_tempo = timeGetTime() - tempo_inicial;
      
      Delta_tempo = Delta_tempo / div_tempo;
      
      Delta_ang = (aceleracao_ang * Delta_tempo * Delta_tempo)/2;
  
   if( Delta_ang <= (ang_disparo*trans_ang)){ 
       
      float dist = (cos(Delta_ang) * (raio));
      y_projetil = (sin(Delta_ang) * (raio))+ y_inicial;
      x_projetil = x_inicial + (cos(ang_projetil * trans_ang)*dist);
      z_projetil = z_inicial - (sin(ang_projetil * trans_ang)*dist);
      
      ang_atirador = Delta_ang / trans_ang;
      
   }else {
          ang_atirador = ang_disparo; 
            
          tempo_inicial = 0;  
           
          mov_circ = true;         
   }
};
////////////////////////////////////////////////////////////////////////////////
void MovimentoProjetil(){
      
      if(y_projetil >= h_final && !mov_proj){  
      
          if(tempo_inicial == 0){
              tempo_inicial = timeGetTime ();      
          }
          Delta_tempo = timeGetTime() - tempo_inicial;
          
          Delta_tempo = Delta_tempo / div_tempo;
          
          float dist = ( vel_horiz * Delta_tempo );
          y_projetil = y_circ_final + ( vel_vert * Delta_tempo ) + ( -9.8 * (Delta_tempo * Delta_tempo) / 2 );
          
          x_projetil = x_circ_final - (cos(ang_projetil * trans_ang)*dist);
          z_projetil = z_circ_final + (sin(ang_projetil * trans_ang)*dist);
          
          if(x_projetil <= x_muro && colisao == 1 && portao){
          
              x_projetil = x_projetil_final;
              y_projetil = y_projetil_final;
              z_projetil = z_projetil_final;
          
              calcula_score();
              mov_proj = true;
          
          }
          if(x_projetil <= x_muro + 3 && colisao_muro == 1){
               x_projetil = (x_muro + 3) - (x_projetil - (x_muro+3));              
          }
          
          
          
          
      }else {
          y_projetil = h_final;
          mov_proj = true;
          if(total_projetil <= 0)
             Fim_de_jogo = true;        
      }
};


void Projetil1(){

             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 1;
                  massa = massa_projetil_A;
                  
                  rcor_base_porj1 = .0;
                  bcor_base_porj1 = .5;
                  gcor_base_porj1 = .5;     
                     
                  rcor_base_porj2 = gcor_base_porj2 = bcor_base_porj2 = .8;
                  rcor_base_porj3 = gcor_base_porj3 = bcor_base_porj3 = .8;
                  
                  cout<<"\nProjetil A selecionado. Massa do Projetil: " << massa; 
             }
};

void Projetil2(){
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 2;
                  massa = massa_projetil_B;
                  
                  rcor_base_porj2 = .0;
                  bcor_base_porj2 = .5;
                  gcor_base_porj2 = .5;
        
                  rcor_base_porj1 = gcor_base_porj1 = bcor_base_porj1 = .8;
                  rcor_base_porj3 = gcor_base_porj3 = bcor_base_porj3 = .8;
                       
                  cout<<"\nProjetil B selecionado. Massa do Projetil: " << massa; 
             }
     
};

void Projetil3(){
             if (!disparar && !mov_circ && !mov_proj){
                  projetil = 3;
                  massa = massa_projetil_C;
                  
                  rcor_base_porj3 = .0;
                  bcor_base_porj3 = .5;
                  gcor_base_porj3 = .5;
        
                  rcor_base_porj1 = gcor_base_porj1 = bcor_base_porj1 = .8;
                  rcor_base_porj2 = gcor_base_porj2 = bcor_base_porj2 = .8;
                       
                  cout<<"\nProjetil C selecionado. Massa do Projetil: " << massa; 
             }
     
};

//****************************************************************************//
/////////////////////////////////////Muro///////////////////////////////////////
void Muro(){
     
glPushMatrix();        
     glTranslatef(x_muro,0,0);
     
    glPushMatrix(); 
       glCallList(lista_castelo);
       glCallList(lista_grade);
    glPopMatrix();
    
    if(mov_portao){
        ang_portao -= incr_portao;
        if(ang_portao<=-90 || ang_portao>=90){
            if (ang_portao<=-90)
                ang_portao = -90;
            else
                ang_portao = 90;
            mov_portao = false;
            portao = false;
            Fim_de_jogo = true;
            ganhou = true;
        }
    
    }
    
    glPushMatrix(); 
       Light_System.set_material( 1.0,  0.9,  0.8, 1.0,
                                  1.0,  0.9,  0.8, 1.0,
                                    0,    0,    0, 1.0,
             1 - intencidade_lua,    1 - intencidade_lua,    1 - intencidade_lua, 1.0,
                        20,  'd');
                        
       glRotatef(ang_portao,0,0,1);
	   glCallList(lista_portao);
    glPopMatrix();
     

     
glPopMatrix();
};

void Colisao(){
     
     ang_projetil = ang_catapulta;
     
     aceleracao = Forca * massa;
     aceleracao_ang = aceleracao/raio;
     
     float dist = (cos(ang_disparo * trans_ang) * (raio));
     y_circ_final = (sin(ang_disparo * trans_ang) * (raio))+ y_inicial;
     x_circ_final = x_inicial + (cos(ang_projetil * trans_ang)*dist);
     z_circ_final = z_inicial - (sin(ang_projetil * trans_ang)*dist);
          
     velocidade  = aceleracao*(sqrt(2*(ang_disparo * trans_ang)/aceleracao_ang)); 
     vel_horiz =  cos((90-ang_disparo)*trans_ang) * velocidade;
     vel_vert  =  sin((90-ang_disparo)*trans_ang) * velocidade;
     
     dist = (x_circ_final - x_muro)/(cos(ang_projetil * trans_ang));
     
     Delta_tempo = dist / vel_horiz;
     
     
     y_projetil_final = y_circ_final + ( vel_vert * Delta_tempo ) + ( -9.8 * (Delta_tempo * Delta_tempo) / 2 );
     x_projetil_final = x_circ_final - (cos(ang_projetil * trans_ang)*dist);
     z_projetil_final = z_circ_final + (sin(ang_projetil * trans_ang)*dist);
     
     
     if(Delta_tempo>0){                 
            if (y_projetil_final <= h_portao&& y_projetil_final >= h_final){    
                 if (z_projetil_final >= -w_portao/2 && z_projetil_final <= w_portao/2){
                      colisao = 1;  
                 }else{
                       colisao = 0;
                 }
            }else{
                  colisao = 0;
            }
            if (y_projetil_final <= h_muro-2 && y_projetil_final >= h_final && colisao < 1){    
                 if (z_projetil_final >= -lag_muro/2 && z_projetil_final <= lag_muro/2){
                      colisao_muro = 1;  
                 }else{
                       colisao_muro = 0;
                 }
            }else{
                  colisao_muro = 0;
            }
                 
     }else{
           colisao = 0;
           colisao_muro = 0;
     }
}

void valores_iniciais(){
     srand(timeGetTime());

     Forca = 80 - rand()%70;
     ang_disparo =  90 - rand()%70;
     
     ang_catapulta =  rand() % 360;
     x_catapulta = 20 - rand()%40;
     z_catapulta = 20 - rand()%40;
     
     AtualizarCoord();
     
     cout<<"\nAngulo: "<<ang_disparo;
     cout<<"\nFora: "<<Forca;
     cout<<"\nMuro: "<<x_muro;
};


//****************************************************************************//
////////////////////////////////Controle FPS////////////////////////////////////

void ControleFPS(void){
     
    static int timer_aux = timeGetTime ();
    static int DELAY  = 1000/FPS_max;
 
    timer_aux = timeGetTime ();      
    if((timeGetTime()- timer_aux)< DELAY)
          Sleep(DELAY - (timeGetTime() - timer_aux));
    
};


////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void AtualizarCoord(){
     x_inicial = x_catapulta;
     y_inicial = y_catapulta;
     z_inicial = z_catapulta;
        
     x_projetil = x_inicial + (cos(ang_catapulta*M_PI/180)*raio);
     y_projetil = y_inicial;
     z_projetil = z_inicial - (sin(ang_catapulta*M_PI/180)*raio); 
};


bool AndarCatapulta(){
     
     float x_aux = x_catapulta + cos(ang_catapulta*M_PI/180)*Desloc_Catap;
     float z_aux = z_catapulta - sin(ang_catapulta*M_PI/180)*Desloc_Catap;
     
     if(z_aux > -25 && z_aux < 25 && x_aux > -25 && x_aux < 25){
         x_catapulta = x_aux;
         z_catapulta = z_aux;
         return true;
     }
     return false;
};

////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

void Interface(){

/***************
/CRIANDO HUD
/***************/
    glPushMatrix();
    
    
    HUD_System.enable(largura,altura);
    
    
    
        
              
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj1,gcor_base_porj1,bcor_base_porj1);
             glVertex3f(.01,.94,0);               
             glVertex3f(.01,.995,0); 
             glVertex3f(.05,.995,0);
             glVertex3f(.05,.94,0);   
        glEnd();   
    
        
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj2,gcor_base_porj2,bcor_base_porj2);         
             glVertex3f(.095,.94,0); 
             glVertex3f(.055,.94,0);               
             glVertex3f(.055,.995,0); 
             glVertex3f(.095,.995,0);             
        glEnd();  
        
        
        glBegin(GL_QUADS); 
             glColor3f(rcor_base_porj3,gcor_base_porj3,bcor_base_porj3);        
             glVertex3f(.14,.94,0); 
             glVertex3f(.1,.94,0);               
             glVertex3f(.1,.995,0); 
             glVertex3f(.14,.995,0);             
        glEnd();
        
        
        glBegin(GL_QUADS); 
             glColor4f(1,1,1,.3);
             glVertex3f(0,.93,0);               
             glVertex3f(1,.93,0); 
             glColor4f(1,1,1,1);
             glVertex3f(1,1,0);
             glVertex3f(0,1,0); 
        glEnd();
        
        glEnable(GL_LIGHTING); 
        glEnable(GL_LIGHT2);
        
            static int ang_proj_inter = 0;
            ang_proj_inter += 10; 
            
            glPushMatrix();
                  glTranslatef(.03,.98,0);
                  glRotatef(ang_proj_inter,1,1,1);
                  glScalef(.035,.035,.035);
                  glCallList(lista_projetil1);
            glPopMatrix(); 	
            
            glPushMatrix(); 
                  glTranslatef(.075,.98,0);
                  glRotatef(ang_proj_inter,1,1,1);
                  glScalef(.035,.035,.035);
                  glCallList(lista_projetil2); 
            glPopMatrix(); 
            
            glPushMatrix();
                  glTranslatef(.12,.98,0);
                  glRotatef(ang_proj_inter,1,1,1);
                  glScalef(.035,.035,.035);
    	          glCallList(lista_projetil3);             
           glPopMatrix();        
        
        glDisable(GL_LIGHT2);
        glDisable(GL_LIGHTING);
        
        
        
          
       glColor3f(0,0,0);  
       char exibir[50];           
       sprintf(exibir, "%i", score_portao );
       Text_System.draw2d("Portao:",.8,.95,2);
       Text_System.draw2d(exibir,.90,.95,2);
       
       
       sprintf(exibir, "%i", q_proj_A);
       Text_System.draw2d(exibir,.025,.945,2);
       sprintf(exibir, "%i", q_proj_B);
       Text_System.draw2d(exibir,.07,.945,2);
       sprintf(exibir, "%i", q_proj_C);
       Text_System.draw2d(exibir,.115,.945,2);
       
       
       Text_System.draw2d("Angulo",.4,.97,2);
       sprintf(exibir, "%f", ang_disparo);
       Text_System.draw2d(exibir,.5,.97,2);
       
       Text_System.draw2d("Forca",.4,.94,2);
       sprintf(exibir, "%f", Forca);
       Text_System.draw2d(exibir,.5,.94,2);
       
       
        
       
            
    HUD_System.disable(ratio,xx,yy,zz,lx,ly,lz);

    glPopMatrix(); 
     
};


void TrataBotaoDireito(){
     
     if(y_HUD >= 0.94 && y_HUD <= 0.995){
               
              if(x_HUD >= 0.01 && x_HUD <= 0.05){
                       
                       Projetil1();                       
                       
              }
              if(x_HUD >= 0.055 && x_HUD <= 0.095){
                       
                       Projetil2();
                       
                       
              }
              if(x_HUD >= 0.1 && x_HUD <= 0.14){
                       
                       Projetil3();
                       
                       
              }
     }
     
};


void SkiBox(){


glEnable(GL_TEXTURE_2D);  
int text = 1;
if(intencidade_lua<.8)
text = 2;

glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);

if(intencidade_lua > .8)
       Light_System.set_material(1,1,1,.4+(.6*intencidade_sol),0,0,'d');
else
       Light_System.set_material(1,1,1,1,0,0,'d');

glBindTexture(GL_TEXTURE_2D,textura[text]);

glCallList(lista_skibox); 

glDisable(GL_TEXTURE_2D);  

}


void carregar_texturas(GLuint id, char *NomeArquivo)
{

IMAGE *img;
GLenum gluerr;
glGenTextures(1, &textura[id]);
glBindTexture(GL_TEXTURE_2D, textura[id]);
  
if(!(img=ImageLoad(NomeArquivo))) 
    {
    MessageBox(NULL,"Falha ao encontrar texturas.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1); 
    }

gluerr=gluBuild2DMipmaps(GL_TEXTURE_2D, 3, img->sizeX, img->sizeY, GL_RGB, 
                             GL_UNSIGNED_BYTE, (GLvoid *)(img->data));
			   
if(gluerr)
    {
    MessageBox(NULL,"Falha ao criar mipmaps.","Erro Fatal",MB_OK|MB_ICONERROR ); 
    exit(-1);
    }

glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
glTexParameterf(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST );
glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_DECAL); 
}

void move_luz(){
    
    ang_sol += incr_luz;
    ang_lua += incr_luz;
    
    
    if (ang_sol>350)
           ang_sol =   -10;
           
    if (ang_lua>350)
           ang_lua =   -10;
           
    if(ang_sol > 180 && dia){   
               srand(timeGetTime()); 
               dia = false;
               flag_nevoa = (rand() % 3);
    }
    else if(!dia && ang_sol > 0 && ang_sol < 180){      
            dia = true;
    }
    
 
    float seno_sol = sin(((ang_sol+10)/200*180)*M_PI/180); 
    if(seno_sol > 0)
           intencidade_sol = seno_sol;
    else
           intencidade_sol = 0;
       
    float seno_lua = sin(((ang_lua+10)/200*180)*M_PI/180);
    if(seno_lua > 0)
           intencidade_lua = 1 - seno_lua;
    else 
           intencidade_lua = 1;
      
    
    py_luz_sol = (sin(ang_sol*M_PI/180)*raio_luz);
    
    float dist = cos(ang_sol*M_PI/180)*raio_luz;
    px_luz_sol = 0 + sin(ang_desl_luz)*dist; 
    pz_luz_sol = 0 - cos(ang_desl_luz)*dist;
    
    
    py_luz_lua = (sin(ang_lua*M_PI/180)*raio_luz);
    
    dist = cos(ang_lua*M_PI/180)*raio_luz;
    
    px_luz_lua = 0 + sin(ang_desl_luz)*dist; 
    pz_luz_lua = 0 - cos(ang_desl_luz)*dist;
    

    
}; 

void calcula_score(){
     switch (projetil){
                         
         case 1 : score_portao -= 60;
         break;
                          
         case 2 : score_portao -= 100;
         break;
                          
         case 3 : score_portao -= 150;
         break;
                          
     } 
     if(score_portao <= 0){
           score_portao = 0;
           projetil = -1;
           mov_portao = true;
           
     }

};

void listas(){

    lista_catapulta   =  glGenLists(1); 
    lista_roda        =  glGenLists(1); 
    lista_atirador    =  glGenLists(1); 
    lista_castelo     =  glGenLists(1); 
    lista_grade       =  glGenLists(1);
    lista_portao      =  glGenLists(1); 
    lista_skibox      =  glGenLists(1);
    lista_skibox_face =  glGenLists(1);
    lista_terreno     =  glGenLists(1); 
    lista_terrenoA    =  glGenLists(1); 
    lista_terrenoB    =  glGenLists(1); 
    lista_tocha       =  glGenLists(1); 
    lista_Arvore1     =  glGenLists(1); 
    lista_Arvore2     =  glGenLists(1);
    lista_Arvore3     =  glGenLists(1);
    lista_Arvore4     =  glGenLists(1);
    lista_projetil1   =  glGenLists(1);
    lista_projetil2   =  glGenLists(1);
    lista_projetil3   =  glGenLists(1);
    
    cout<<"\nObjeto Modelado 1 ..."; 
    carregar_texturas(3,"textures/Textura_Catapulta.rgb");cout<<".Textura ok!...";  
    pmodel1=drawmodel("models/Catapulta_Base_tex.obj","texture");cout<<".Modelo ok!..."; 
    glNewList(lista_catapulta, GL_COMPILE);    
        glPushMatrix(); 
               glEnable(GL_TEXTURE_2D);  
               glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
               Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0.0,'d');
               glBindTexture(GL_TEXTURE_2D,textura[3]);
        	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
        	   glDisable(GL_TEXTURE_2D);  
        glPopMatrix();
    glEndList();
    
    cout<<".List ok!\nObjeto Modelado 2 ...";  
    carregar_texturas(3,"textures/Roda.rgb");cout<<".Textura ok!...";  
    pmodel1=drawmodel("models/Roda_tex.obj","texture");cout<<".Modelo ok!..."; 
    glNewList(lista_roda, GL_COMPILE); 
        glPushMatrix(); 
           glEnable(GL_TEXTURE_2D); 
           glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE); 
           glBindTexture(GL_TEXTURE_2D,textura[3]);
           Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0,'d');     
    	   glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    	   glDisable(GL_TEXTURE_2D); 
        glPopMatrix();
    glEndList();
    
    cout<<".List ok!\nObjeto Modelado 3 ...";  
    carregar_texturas(3,"textures/mad007.rgb");cout<<".Textura ok!...";   
    pmodel1=drawmodel("models/Atirador_tex.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_atirador, GL_COMPILE); 
         glPushMatrix();
            glEnable(GL_TEXTURE_2D);  
            glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
            glBindTexture(GL_TEXTURE_2D,textura[3]);
            Light_System.set_material(1.0,1.0,0.0,1.0,0,0,'d');
    	    glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    	    glDisable(GL_TEXTURE_2D);
         glPopMatrix(); 
    glEndList(); 
    
    cout<<".List ok!\nObjeto Modelado 4 ...";  
    carregar_texturas(3,"textures/MuroA.rgb");cout<<".Textura ok!...";   
    pmodel1=drawmodel("models/Castelo_tex.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_castelo, GL_COMPILE); 
         glPushMatrix();
               glEnable(GL_TEXTURE_2D);  
               glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
               Light_System.set_material(1.0,0.9,0.8,1.0,0.0,0.0,'d');
               glBindTexture(GL_TEXTURE_2D,textura[3]); 
               glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
    glPopMatrix(); 
    glEndList(); 
       
    cout<<".List ok!\nObjeto Modelado 5 ...";     
    carregar_texturas(3,"textures/Grade.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Grade.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_grade, GL_COMPILE); 
         glPushMatrix();
               glEnable(GL_TEXTURE_2D);  
               glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
               Light_System.set_material(1.0,0.9,0.8,1.0,0.0,0.0,'d');
               glBindTexture(GL_TEXTURE_2D,textura[3]); 
               glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
               glDisable(GL_TEXTURE_2D);  
         glPopMatrix(); 
    glEndList(); 
    
    cout<<".List ok!\nObjeto Modelado 6 ...";   
    
    carregar_texturas(3,"textures/mad043.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Portao_tex.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_portao, GL_COMPILE); 
         glPushMatrix();
               glEnable(GL_TEXTURE_2D);  
               glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
               glBindTexture(GL_TEXTURE_2D,textura[3]); 
               glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
               glDisable(GL_TEXTURE_2D);  
         glPopMatrix(); 
    glEndList(); 
    
    cout<<".List ok!\nObjeto Modelado 7 ...";   
    carregar_texturas(3,"textures/TerraC.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Terreno_A.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_terrenoA, GL_COMPILE); 
       glEnable(GL_CULL_FACE);   
         glPushMatrix();
             glEnable(GL_TEXTURE_2D);  
             glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
             Light_System.set_material(0.9,0.9,0.9,1.0,0.0,0,'d'); 
             glBindTexture(GL_TEXTURE_2D,textura[3]); 
             glScalef(1.6,1.6,1.6); 
             glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
             glDisable(GL_TEXTURE_2D);  
         glPopMatrix(); 
      glDisable(GL_CULL_FACE);
    glEndList(); 
    
    
    cout<<".List ok!\nObjeto Modelado 8 ...";  
    carregar_texturas(3,"textures/Grama.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Terreno_B.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_terrenoB, GL_COMPILE); 
      glEnable(GL_CULL_FACE);   
         glPushMatrix();
             glEnable(GL_TEXTURE_2D);  
             glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
             Light_System.set_material(0.5,0.7,0.5,1.0,0.0,0,'d'); 
             glBindTexture(GL_TEXTURE_2D,textura[3]); 
             glScalef(1.6,1.6,1.6); 
             glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
             glDisable(GL_TEXTURE_2D);
         glPopMatrix(); 
      glDisable(GL_CULL_FACE);
    glEndList();
    
    cout<<".List ok!\nObjeto Modelado 9 ...";
    carregar_texturas(3,"textures/Tocha.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Tocha.obj","texture");cout<<".Modelo ok!...";
    glNewList(lista_tocha, GL_COMPILE); 
         glEnable(GL_CULL_FACE); 
         glPushMatrix();
             glEnable(GL_TEXTURE_2D);  
             glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
             Light_System.set_material(0.8,0.8,0.8,1.0,1.0,0,'d'); 
             glBindTexture(GL_TEXTURE_2D,textura[3]); 
             glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
             glDisable(GL_TEXTURE_2D);
         glPopMatrix(); 
         glDisable(GL_CULL_FACE);
    glEndList();
    
    cout<<".List ok!\nObjeto Modelado 10 ...";
    carregar_texturas(3,"textures/Rocha.rgb");cout<<".Textura ok!...";
    pmodel1=drawmodel("models/Pedra.obj","texture");cout<<".Modelo ok!..."; 
    glNewList(lista_projetil3, GL_COMPILE); 
         glEnable(GL_CULL_FACE); 
         glPushMatrix();
             glEnable(GL_TEXTURE_2D);  
             glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
             Light_System.set_material(1.0,1.0,1.0,1.0,.8,0,'d');
             glBindTexture(GL_TEXTURE_2D,textura[3]);
             glScalef(.4,.4,.4);
             glmDraw(pmodel1, GLM_TEXTURE | GLM_SMOOTH );
             glDisable(GL_TEXTURE_2D);
         glPopMatrix(); 
         glDisable(GL_CULL_FACE);
    glEndList();
    
    cout<<".List ok!\n\nObjeto Interno  1 ....";    
    carregar_texturas_sprite(3,"textures/Arvore_Cad_1.bmp",25);cout<<".Textura ok!...Criando.....";
    glNewList(lista_Arvore1, GL_COMPILE); 
         glEnable(GL_TEXTURE_2D);  
         glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
         Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0,'d'); 
         glBindTexture(GL_TEXTURE_2D,textura[3]); 
         glPushMatrix();
             float Alt = 40;
             float Larg = 32;
             float fundura = 0.1;
             glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(-Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,0);
                glVertex3f(+Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,1);
                glVertex3f(+Larg/2,Alt-fundura,+Larg/2);
                glTexCoord2f(0,1);
                glVertex3f(-Larg/2,Alt-fundura,+Larg/2); 
           glEnd();
         glPopMatrix(); 
         glDisable(GL_TEXTURE_2D);
    glEndList();
    
    cout<<"..ok!\nObjeto Interno  2 ....";   
    
    carregar_texturas_sprite(3,"textures/Arvore_Cad_2.bmp",25);cout<<".Textura ok!...Criando.....";
    glNewList(lista_Arvore2, GL_COMPILE); 
         glEnable(GL_TEXTURE_2D);  
         glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
         Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0,'d'); 
         glBindTexture(GL_TEXTURE_2D,textura[3]); 
         glPushMatrix();
             Alt = 40;
             Larg = 32;
             fundura = 0.1;
             glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(-Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,0);
                glVertex3f(+Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,1);
                glVertex3f(+Larg/2,Alt-fundura,+Larg/2);
                glTexCoord2f(0,1);
                glVertex3f(-Larg/2,Alt-fundura,+Larg/2); 
           glEnd();
         glPopMatrix(); 
         glDisable(GL_TEXTURE_2D);
    glEndList();
    
    cout<<"..ok!\nObjeto Interno  3 ....";  
    
    carregar_texturas_sprite(3,"textures/Arvore_Cad_3.bmp",25);cout<<".Textura ok!...Criando.....";
    glNewList(lista_Arvore3, GL_COMPILE); 
         glEnable(GL_TEXTURE_2D);  
         glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
         Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0,'d'); 
         glBindTexture(GL_TEXTURE_2D,textura[3]); 
         glPushMatrix();
             Alt = 40;
             Larg = 32;
             fundura = 0.1;
             glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(-Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,0);
                glVertex3f(+Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,1);
                glVertex3f(+Larg/2,Alt-fundura,+Larg/2);
                glTexCoord2f(0,1);
                glVertex3f(-Larg/2,Alt-fundura,+Larg/2); 
           glEnd();
         glPopMatrix(); 
         glDisable(GL_TEXTURE_2D);
    glEndList();
    
    cout<<"..ok!\nObjeto Interno  4 ....";  
    
    carregar_texturas_sprite(3,"textures/Arvore_Cad_4.bmp",25);cout<<".Textura ok!...Criando.....";
    glNewList(lista_Arvore4, GL_COMPILE); 
         glEnable(GL_TEXTURE_2D);  
         glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
         Light_System.set_material(1.0,1.0,1.0,1.0,0.0,0,'d'); 
         glBindTexture(GL_TEXTURE_2D,textura[3]); 
         glPushMatrix();
             Alt = 40;
             Larg = 32;
             fundura = 0.1;
             glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(-Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,0);
                glVertex3f(+Larg/2,fundura,+Larg/2);
                glTexCoord2f(1,1);
                glVertex3f(+Larg/2,Alt-fundura,+Larg/2);
                glTexCoord2f(0,1);
                glVertex3f(-Larg/2,Alt-fundura,+Larg/2); 
           glEnd();
         glPopMatrix(); 
         glDisable(GL_TEXTURE_2D);
    glEndList();
    
    cout<<"..ok!\nObjeto Interno  5 .....Sem Textura!...Criando....."; 
    glNewList(lista_projetil1, GL_COMPILE); 
         glEnable(GL_CULL_FACE); 
         glPushMatrix();
             glScalef(.25,.25,.25);
             Light_System.set_material( 0.21,  0.13,  0.05, 1.0,
                                        0.71,  0.43,  0.18, 1.0,
                                        0.39,  0.27,  0.17, 1.0,
                                           0,     0,     0, 1.0,
                                        26, 'd');
             glutSolidSphere(1, 20, 20);
         glPopMatrix(); 
         glDisable(GL_CULL_FACE);
    glEndList();
    
    cout<<"..ok!\nObjeto Interno  6 .....Sem Textura!...Criando....."; 
    glNewList(lista_projetil2, GL_COMPILE); 
         glEnable(GL_CULL_FACE); 
         glPushMatrix();
             glScalef(.25,.4,.325);
             Light_System.set_material( 0.25,  0.20,  0.07, 1.0,
                                        0.75,  0.61,  0.23, 1.0,
                                        0.63,  0.56,  0.37, 1.0,
                                           0,     0,     0, 1.0,
                                        51, 'd');
             glutSolidSphere(1, 20, 20);
         glPopMatrix(); 
         glDisable(GL_CULL_FACE);
    glEndList();
    
    
        
    
    cout<<"..ok!\nObjeto Interno  7 .....Sem Textura!...Criando....."; 
    float tamskibox = 250;
    glNewList(lista_skibox, GL_COMPILE); 
        //CRIANDO SKYBOX
        glEnable(GL_CULL_FACE);   
       glPushMatrix();
            glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(  -tamskibox,-10,+tamskibox);               
                glTexCoord2f(1,0);
                glVertex3f(   -tamskibox,-10,-tamskibox); 
                glTexCoord2f(1,1);
                glVertex3f(  -tamskibox,+tamskibox,-tamskibox);
                glTexCoord2f(0,1);
                glVertex3f(  -tamskibox,+tamskibox,+tamskibox);
           glEnd();   
        glPopMatrix();
        
        
        glPushMatrix();
        
           glBegin(GL_QUADS); 
                glTexCoord2f(1,0);            
                glVertex3f(+tamskibox,-10,+tamskibox);
                glTexCoord2f(0,0);
                glVertex3f(-tamskibox,-10,+tamskibox);
                glTexCoord2f(0,1);
                glVertex3f(-tamskibox,+tamskibox,+tamskibox);
                glTexCoord2f(1,1);
                glVertex3f(+tamskibox,+tamskibox,+tamskibox); 
           glEnd(); 
        
        glPopMatrix(); 
        
        
         
        glPushMatrix();
            glBegin(GL_QUADS); 
                glTexCoord2f(0,0);            
                glVertex3f(+tamskibox,-10,-tamskibox);               
                glTexCoord2f(1,0);
                glVertex3f(+tamskibox,-10,+tamskibox); 
                glTexCoord2f(1,1);
                glVertex3f(+tamskibox,+tamskibox,+tamskibox);
                glTexCoord2f(0,1);
                glVertex3f(+tamskibox,+tamskibox,-tamskibox);
        
        
           glEnd(); 
        glPopMatrix();
        
        glPushMatrix();
            glBegin(GL_QUADS); 
                glTexCoord2f(1,0);            
                glVertex3f(-tamskibox,-10,-tamskibox);
                glTexCoord2f(0,0);
                glVertex3f(+tamskibox,-10,-tamskibox);
                glTexCoord2f(0,1);
                glVertex3f(+tamskibox,+tamskibox,-tamskibox);
                glTexCoord2f(1,1);
                glVertex3f(-tamskibox,+tamskibox,-tamskibox); 
           glEnd(); 
        glPopMatrix();  
        
        glDisable(GL_CULL_FACE); 
        
    glEndList(); 
      
    
    
    cout<<"..ok!\n\nConjunto de Objetos ....Criando....."; 
    glNewList(lista_terreno, GL_COMPILE); 
         for (int i = 0; i< 5; i++)
            for(int j = 0; j< 5; j++){
                    if(i!= 2 || j != 2){
                        glPushMatrix();
                            glTranslatef(-200+(100*i),0,-200+(100*j));
                            glCallList(lista_terrenoB);  
                        glPopMatrix();   
                    }else{
                          glCallList(lista_terrenoA);        
                    }
            }
    glEndList();
    cout<<"..ok!\n"; 


};


void Terreno(){
     glPushMatrix();
  
              
         glCallList(lista_terreno);

     
     glPopMatrix(); 
};


void Tocha(){
     
     int pos = 30;
      
     glPushMatrix();
         glTranslatef(-pos,0,-pos);
         glCallList(lista_tocha);
     glPopMatrix(); 
     
     glPushMatrix();
         glTranslatef(-pos,0,pos);
         glCallList(lista_tocha);
     glPopMatrix(); 
     
     glPushMatrix();
         glTranslatef(pos,0,-pos);
         glCallList(lista_tocha);
     glPopMatrix(); 
     
     glPushMatrix();
         glTranslatef(pos,0,pos);
         glCallList(lista_tocha);
     glPopMatrix(); 
};

void Arvores(){
     
     glPushMatrix();
         glTranslatef(-180,0,180);
         glRotatef(90,0,1,0);
         glCallList(lista_Arvore1);
     glPopMatrix(); 
     
     
     glPushMatrix();
         glTranslatef(-150,0,-150);
         glRotatef(90,0,1,0);
         glCallList(lista_Arvore3);
     glPopMatrix(); 

     glPushMatrix();
         glTranslatef(-140,0,130);
         glRotatef(90,0,1,0);
         glCallList(lista_Arvore2);
     glPopMatrix(); 
     
     glPushMatrix();
         glTranslatef(-130,0,-100);
         glRotatef(90,0,1,0);
         glCallList(lista_Arvore4);
     glPopMatrix(); 
     
 
};


void carregar_texturas_sprite(GLuint id, char *NomeArquivo, int faixa)  {
     
    AUX_RGBImageRec *pImage_RGB = auxDIBImageLoad(NomeArquivo);
    unsigned char *pImage_RGBA = NULL;

    if( pImage_RGB != NULL )
    {
        int imageSize_RGB  = pImage_RGB->sizeX * pImage_RGB->sizeY * 3;
        int imageSize_RGBA = pImage_RGB->sizeX * pImage_RGB->sizeY * 4;

        pImage_RGBA = new unsigned char[imageSize_RGBA];

        int i, j;

        for( i = 0, j = 0; i < imageSize_RGB; i += 3, j += 4 )
        {
            //A cor do pixel  a cor definida na key-color?
            if( pImage_RGB->data[i]   < g_keyColor[0] + faixa && pImage_RGB->data[i]   > g_keyColor[0] - faixa &&
                pImage_RGB->data[i+1] < g_keyColor[1] + faixa && pImage_RGB->data[i]   > g_keyColor[1] - faixa &&
                pImage_RGB->data[i+2] < g_keyColor[2] + faixa && pImage_RGB->data[i]   > g_keyColor[2] - faixa)
            {
                pImage_RGBA[j+3] = 0;   //Ento, definir transparencia 100%
            }
            else
            {
                pImage_RGBA[j+3] = 255; //Caso contrario definir transparencia 0%
            }

            pImage_RGBA[j]   = pImage_RGB->data[i];
            pImage_RGBA[j+1] = pImage_RGB->data[i+1];
            pImage_RGBA[j+2] = pImage_RGB->data[i+2];
        }

        glGenTextures(1, &textura[id]);
        glBindTexture(GL_TEXTURE_2D, textura[id]);
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER, GL_NEAREST);
        glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER, GL_NEAREST);

       
        glTexImage2D( GL_TEXTURE_2D, 0, GL_RGBA, pImage_RGB->sizeX, pImage_RGB->sizeY, 0,
                      GL_RGBA, GL_UNSIGNED_BYTE, pImage_RGBA );
    }

    if( pImage_RGB )
    {
        if( pImage_RGB->data )
            free( pImage_RGB->data );

        free( pImage_RGB );
    }

    if( pImage_RGBA )
        delete [] pImage_RGBA;
}


void Final(){
/***************
/CRIANDO HUD
/***************/
    glPushMatrix();
      
    
    HUD_System.enable(largura,altura);
        
        glBegin(GL_QUADS); 
             glColor4f(.6,.6,.6,.95);
             glVertex3f(0.7,0.7,0); 
             glVertex3f(0.3,0.7,0);
             glColor4f(.6,.6,.6,.3);
             glVertex3f(0.3,0.3,0); 
             glVertex3f(0.7,0.3,0);
        glEnd();
        
        glEnable(GL_LIGHTING); 
        glEnable(GL_LIGHT2);
        
            static int ang_proj_inter = 0;
            ang_proj_inter += 10; 
            
            glPushMatrix();
                  glTranslatef(.5,.4,0);
                  glRotatef(ang_proj_inter,1,1,1);
                  glScalef(.2,.2,.2);
    	          glCallList(lista_projetil3);             
           glPopMatrix();        
        
        glDisable(GL_LIGHT2);
        glDisable(GL_LIGHTING);
       
         
       char exibir[50];   
        
       ganhou = 0;
       
       glColor3f(1,0,0);
       if(ganhou)  
             glColor3f(0,0,1);
       Text_System.draw2d("Fim de Jogo!",.43,.65,4);  
        
       
       Text_System.draw2d("Pontos:",.43,.58,4);
       sprintf(exibir, "%i", total_projetil*10);
       Text_System.draw2d(exibir,.55,.58,4);
               
       
       glColor3f(0,0,0);
       Text_System.draw2d("Precione: N   - Novo Jogo",.43,.52,2);
       Text_System.draw2d("          Esc - Sair",.43,.47,2);
            
    HUD_System.disable(ratio,xx,yy,zz,lx,ly,lz);
    glPopMatrix(); 
};

void Tela_Inicial(){
/***************
/CRIANDO HUD
/***************/
    glPushMatrix();
    HUD_System.enable(largura,altura);

        glEnable(GL_TEXTURE_2D);  
        glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
        glBindTexture(GL_TEXTURE_2D,textura[4]); 
        
        glBegin(GL_QUADS); 
             glColor4f(.6,.6,.6,inicio);
             glTexCoord2f(0,0);
             glVertex3f(0,0,0);
             glTexCoord2f(0,1);
             glVertex3f(0,1,0);
             glTexCoord2f(1,1);
             glVertex3f(1,1,0); 
             glTexCoord2f(1,0);
             glVertex3f(1,0,0);
        glEnd();
        glDisable(GL_TEXTURE_2D);

    HUD_System.disable(ratio,xx,yy,zz,lx,ly,lz);
    glPopMatrix(); 
};
